# == funky's VM ==
FUNKY_DOMAIN = "funky.test"
FUNKY_IP = "172.16.245.200"
FUNKY_PUB_IP = "192.168.1.200"
FUNKY_NAME = "funky"

# 👋 don't forget to add IPs and domain in your hosts file

BOX_IMAGE = "bento/ubuntu-16.04"
VERSION = "1.0"

Vagrant.configure("2") do |config|
  config.vm.box = BOX_IMAGE

  ENV['LC_ALL']="en_US.UTF-8"

  config.vm.synced_folder "./", "/home", id:"home"

  config.vm.define "#{FUNKY_NAME}" do |node| 

    #node.vm.network :forwarded_port, guest: 80, host: 8083
    node.vm.hostname = "#{FUNKY_NAME}"
    
    node.vm.network "public_network", ip:"#{FUNKY_PUB_IP}",  bridge: "en0: Wi-Fi (AirPort)"
    #node.vm.network "public_network", bridge: "en0: Wi-Fi (AirPort)"
    #⚠️ find the equivalent cmd for Linux
    node.vm.network "private_network", ip: "#{FUNKY_IP}"

    node.vm.provider "virtualbox" do |vb|
      vb.memory = 512
      vb.cpus = 1
      vb.name = "#{FUNKY_NAME}-vm"
    end

    node.vm.provision :shell, inline: <<-SHELL
      echo "👋 setup"

      apt-get update
      apt-get install -y default-jdk
      apt-get install mc -y

      #apt-get install snapd snapd-xdg-open -y
      #snap install --classic kotlin 

      # Install NodeJS
      curl -sL https://deb.nodesource.com/setup_11.x | sudo -E bash -
      apt-get -y install nodejs

      # TODO try with docker

      # Add entries to hosts file:
      echo "" >> /etc/hosts
      echo '#{FUNKY_IP} #{FUNKY_DOMAIN}' >> /etc/hosts 
      echo "" >> /etc/hosts

      npm install -g nodemon

      #TODO 
    SHELL

    #node.vm.provision :shell, run: "always", inline: <<-SHELL
    #
    #SHELL

    node.vm.provision :shell, path: "init.sh", run: "always", privileged: false

  end
  # end of VM of the bot

end